all: a

a: a.s
	riscv64-unknown-elf-as -march=rv64ic $? -o a.o
	riscv64-unknown-elf-ld -T a.ld -melf64lriscv a.o -o $@

clean:
	rm -fr a
	rm -fr a.o
	rm -fr cpu.log

run:
	qemu-system-riscv64 -machine virt -bios none -kernel a -m 128M -nographic -serial mon:stdio

debug:
	qemu-system-riscv64 -machine virt -bios none -kernel a -m 128M -nographic -monitor telnet::45454,server,nowait -serial mon:stdio -S -gdb tcp::25501 -singlestep -d cpu,nochain,in_asm,mmu -D cpu.log
	#qemu-system-riscv64 -machine virt -bios none -kernel a -m 128M -nographic -monitor telnet::45454,server,nowait -serial mon:stdio -singlestep -d cpu,nochain,in_asm,mmu -D cpu.log -S -gdb tcp::25501

dts:
	qemu-system-riscv64 -machine virt -machine dumpdtb=riscv64-virt.dtb
	dtc -I dtb -O dts -o riscv64-virt.dts riscv64-virt.dtb
